<template>
  <div class="catalog-page">
    <h1>Catalog: {{ id }}</h1>
    <template v-if="catalog">
      <CatalogViewer :catalog="catalog" :page="pageAsNumber" />
    </template>
    <div class="controls">
      <button @click="onLeft">←</button>
      <input type="number" step="2" v-model="page" />
      <button @click="onRight">→</button>
      <br />
      <button @click="onUp">↑</button>
      <button @click="onDown">↓</button>
    </div>
    <pre>{{ pageInfo }}</pre>
  </div>
</template>

<script lang="ts">
import { Options, Vue } from "vue-class-component";
import { mapActions } from "vuex";
import { Catalog } from "@/models/Catalog";
import CatalogViewer from "@/components/CatalogViewer.vue";
import { Page } from "@/models/Page";

@Options({
  name: CatalogPage.name,
  components: { CatalogViewer },
  props: {
    id: String,
  },
  methods: {
    ...mapActions(["getCatalog"]),
  },
  watch: {
    page(value: string | number) {
      if (!this.catalog || !this.catalog.pages) this.page = 1;

      value = parseInt(value + "");
      if (value < 1) this.page = 1;
      if (value > this.catalog.pages.length)
        this.page = this.catalog.pages.length;
    },
  },
})
export default class CatalogPage extends Vue {
  id!: string;
  catalog: Catalog | null = null;
  page: string | number = 0;

  /**
  async beforeRouteEnter(to: RouteLocationNormalized): Promise<void> {
    console.log("beforeRouteEnter");
    await fetchData();
  }

  async beforeRouteUpdate(to: RouteLocationNormalized): Promise<void> {
    console.log("beforeRouteUpdate");
    await fetchData();
  }
  **/

  getCatalog!: (id: string) => Promise<Catalog>;

  created(): void {
    window.addEventListener("keydown", this.processCommand);
  }

  mounted(): void {
    this.fetchData();
  }

  unmounted(): void {
    window.removeEventListener("keydown", this.processCommand);
  }

  async fetchData(): Promise<void> {
    try {
      this.catalog = await this.getCatalog(this.id);
      console.log(`Fetched catalog ${this.id}:`, this.catalog);
    } catch (e) {
      console.warn(`Unable to load the catalog ${this.id}:`, e);
    }
  }

  get pageAsNumber(): number {
    return parseInt(this.page + "");
  }

  /** Controls */

  processCommand(event: KeyboardEvent): void {
    // console.log("processCommand(event):", event);

    switch (event.key) {
      case "Down": // IE/Edge specific value
      case "ArrowDown":
        // Do something for "down arrow" key press.
        this.onDown();
        break;
      case "Up": // IE/Edge specific value
      case "ArrowUp":
        // Do something for "up arrow" key press.
        this.onUp();
        break;
      case "Left": // IE/Edge specific value
      case "ArrowLeft":
        // Do something for "left arrow" key press.
        this.onLeft();
        break;
      case "Right": // IE/Edge specific value
      case "ArrowRight":
        // Do something for "right arrow" key press.
        this.onRight();
        break;
      case "Enter":
        // Do something for "enter" or "return" key press.
        break;
      case "Esc": // IE/Edge specific value
      case "Escape":
        // Do something for "esc" key press.
        break;
      default:
        return; // Quit when this doesn't handle the key event.
    }
  }

  onLeft(): void {
    this.page = this.pageAsNumber - 2;
  }

  onRight(): void {
    this.page = this.pageAsNumber + 2;
  }

  onUp(): void {
    console.log("up");
  }

  onDown(): void {
    console.log("down");
  }

  /** Page management */

  get pageIndex(): number {
    const index = this.pageAsNumber - 1;
    if (index < 0 || !this.catalog?.pages) return 0;
    if (index >= this.catalog?.pages.length)
      return this.catalog.pages.length - 1;
    return index;
  }

  get pageInfo(): Page | undefined {
    if (!this.catalog?.pages) return undefined;
    return this.catalog?.pages[this.pageIndex];
  }
}
</script>

<style lang="scss">
.catalog-page {
  .controls {
    button {
      padding: 1em;
      font-weight: bold;
      text-transform: full-width;
    }
  }

  pre {
    text-align: left;
  }
}
</style>
